C     (Main Program)
C     Perform system-dependent file  associations, then call  the
C     character primitive test package.
C     (04-APR-85)
C
C     EXTERNAL REFS       CHRTST,      SYSDEC
C
C     CALL SYSDEC (5,6)
      CALL CHRTST (5,6)
      STOP
      END
      SUBROUTINE  AFILL (BUFFER,MAXBUF,VALUE)
C     (Array Fill)
C     (30-MAR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                BUFFER,      I
C
      CHARACTER           BUFFER(*),   VALUE
      INTEGER             I,           MAXBUF
C
      I =1
      N20001=MAXBUF
      GO TO 20002
20001 I =I +1
20002 IF ((N20001-I ).LT.0) GO TO 20003
      BUFFER(I) = VALUE
      GO TO 20001
C
20003 RETURN
      END
      LOGICAL FUNCTION  ALPHA (TEXT,LOC)
C     (Alpha)
C     Return .TRUE. if TEXT contains the characters in range A..Z
C     beginning at LOC, and .FALSE. otherwise.
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRORD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRORD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                OFFSET,      ORD,         ORDUCA,      ORDUCZ
C
      CHARACTER           TEXT(*)
      INTEGER             LOC,         OFFSET,      ORD
      INTEGER             ORDUCA,      ORDUCZ
C
      ORDUCA = CHRORD('A')
      ORDUCZ = CHRORD('Z')
      OFFSET = 0
      ORD = ORDUCA
      GO TO 20002
20001 IF ((.NOT.ALPHA) .OR. (ORD .GT. ORDUCZ)) GO TO 20003
20002 ALPHA = (ORD .EQ. CHRORD(TEXT(LOC+OFFSET)))
      OFFSET = OFFSET + 1
      ORD = ORD + 1
      GO TO 20001
C
20003 RETURN
      END
      LOGICAL FUNCTION  ASCLCL (MAXORD,NOUT)
C     (CHRASC/CHRLCL Test)
C     Requires correct CHRCHR
C     (04-SEP-87)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRASC,      CHRCHR,      CHRLCL
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRCHR,      CHRLCL
      INTEGER             CHRASC
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CH,          CHAR1,       CHAR2,       MAXASC
C     SETS                OK,          ORD,         ORDASC
C
      CHARACTER           CH,          CHAR1,       CHAR2
      INTEGER             MAXASC
      INTEGER             MAXORD,      NOUT,        ORD,         ORDASC
      INTEGER             LSTHOL,      ORDM1
      LOGICAL             OK,          HOLE
C
      DATA                MAXASC    / 127 /
C
      OK = .TRUE.
      HOLE = .FALSE.
      ORD =0
      N20001=MAXORD
      GO TO 20002
20001 ORD =ORD +1
20002 IF ((N20001-ORD ).LT.0) GO TO 20003
      CHAR1 = CHRCHR(ORD)
      CHAR2 = CHAR1
      ORDASC = CHRASC(CHAR2)
      IF (.NOT.(CHAR1 .NE. CHAR2)) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,7000)
20005 CONTINUE
20006 IF (.NOT.(ORDASC .EQ. (-1))) GO TO 20008
      IF (.NOT.(.NOT. HOLE)) GO TO 20011
      LSTHOL = ORD
20011 CONTINUE
20012 HOLE = .TRUE.
      GO TO 20009
20008 IF (.NOT.((ORDASC .LT. (-1)) .OR. (127 .LT. ORDASC))) GO TO 10001
      OK = .FALSE.
      WRITE (NOUT,2000) ORD,ORDASC,MAXASC
      GO TO 20009
10001 IF (.NOT.(HOLE)) GO TO 10002
      HOLE = .FALSE.
      IF (.NOT.( (LSTHOL+1) .NE. ORD)) GO TO 20014
      ORDM1 = ORD - 1
      WRITE (NOUT, 9000) LSTHOL, ORDM1
      GO TO 20015
20014 WRITE (NOUT, 1000) LSTHOL
20015 CONTINUE
10002 CONTINUE
20009 GO TO 20001
20003 IF (.NOT.(HOLE)) GO TO 20017
      IF (.NOT.( (LSTHOL+1) .NE. MAXORD)) GO TO 20020
      WRITE (NOUT, 9000) LSTHOL, MAXORD
      GO TO 20021
20020 WRITE (NOUT, 1000) LSTHOL
20021 CONTINUE
C
20017 ORDASC =0
      GO TO 20024
20023 ORDASC =ORDASC +1
20024 IF ((127-ORDASC ).LT.0) GO TO 20025
      ORD = ORDASC
      CH = CHRLCL(ORD)
      IF (.NOT.(ORD .NE. ORDASC)) GO TO 20027
      OK = .FALSE.
      WRITE (NOUT,8000)
20027 ORD = CHRASC(CH)
      IF (.NOT.(ORD .NE. ORDASC)) GO TO 20030
      OK = .FALSE.
      WRITE (NOUT,4000) ORDASC,ORD,ORDASC
20030 GO TO 20023
C
20025 IF (.NOT.(OK)) GO TO 20033
      WRITE (NOUT,6000)
      GO TO 20034
20033 WRITE (NOUT,5000)
20034 ASCLCL = OK
C
      RETURN
C
 1000 FORMAT (' Host ordinal ',I3,' has no ASCII equivalent.')
 2000 FORMAT (' **ERROR** ',' CHRASC(CHRCHR(',I3,')) = ',I3,
     X' - not in range 0..',I3//)
 3000 FORMAT (' ASCII ordinal ',I3,
     X' has no equivalent in host character set.')
 4000 FORMAT (' **ERROR** ',' CHRASC(CHRLCL(',I3,')) returns ',I3,
     X' instead of ',I3//)
 5000 FORMAT (' CHRASC/CHRLCL test FAILED.'//)
 6000 FORMAT (' CHRASC/CHRLCL test OK.'//)
 7000 FORMAT (' CHRASC FAILURE - Argument modified.'//)
 8000 FORMAT (' CHRLCL FAILURE - Argument modified.'//)
 9000 FORMAT (' Host ordinals in the range of  '/
     X' ',I3, ' through ',I3, ' have no ASCII equivalent.')
C
      END
      LOGICAL FUNCTION  COMPA2 (SOURCE,TARGET,MAXBUF,NUMCPW,NOUT)
C     (CHRCM2 Test)
C     Requires correct CHRLC,CHRLCL
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AFILL,       CHRCM2,      CHRLC,       CHRLCL
C     EXTERNAL REFS       LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRLC,       CHRLCL
      INTEGER             CHRCM2
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             IN
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CHAR1,       CHAR2,       CTEMP
C     SETS                LEN1,        LOC,         LOC1,        LOC2
C     SETS                OFFSET,      OK
C     SETS                OK1,         OK2,         ORD,         ORD2
C
      CHARACTER           CHAR0,       CHAR1,       CHAR2,       CTEMP
      CHARACTER           SOURCE(*),   TARGET(*)
      INTEGER             ARG1,        ARG2,        ARG3,        LEN0
      INTEGER             LEN1,        LOC,         LOC1,        LOC2
      INTEGER             MAXBUF,      NOUT
      INTEGER             NUMCPW,      OFFSET,      ORD,         ORD2
      INTEGER             RESULT
      LOGICAL             OK,          OK1,         OK2
C
      IN(ARG1,ARG2,ARG3) = (ARG1 .LE. ARG2) .AND. (ARG2 .LE. ARG3)
C
      OK = .TRUE.
      OK1 = .TRUE.
      OK2 = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL LETTER (SOURCE,LOC,LEN0)
      CALL LETTER (TARGET,LOC,LEN0)
      LOC1 = LOC
      LOC2 = LOC
      LEN1 = LEN0
      OK1 = OK1 .AND. (CHRCM2(SOURCE(LOC1),TARGET(LOC2),LEN1) .EQ.
     X0)
      IF (.NOT.((LOC1 .NE. LOC) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLEN0) )) GO TO 20005
      OK1 = .FALSE.
      WRITE (NOUT,8000) LOC,LOC,LEN0,LOC1,LOC2,LEN1
20005 OFFSET =0
      N20008=LEN0-1
      GO TO 20009
20008 OFFSET =OFFSET +1
20009 IF ((N20008-OFFSET ).LT.0) GO TO 20010
      SOURCE(LOC+OFFSET) = CHRLC(SOURCE(LOC+OFFSET))
      GO TO 20008
20010 OK2 = OK2 .AND. (CHRCM2(SOURCE(LOC),TARGET(LOC),LEN0) .EQ. 0)
      IF (.NOT.(CHRCM2(SOURCE(LOC),TARGET(LOC),0) .NE. 0)) GO TO 20012
      OK2 = .FALSE.
      WRITE (NOUT,9000)
20012 GO TO 20001
20003 OK = OK .AND. OK1 .AND. OK2
      IF (.NOT.OK1) WRITE (NOUT,3000)
      IF (.NOT.OK2) WRITE (NOUT,4000)
C
C     Inequality tests.
C
      CALL AFILL (SOURCE,MAXBUF,'A')
      CALL AFILL (TARGET,MAXBUF,'Z')
      OK1 = (CHRCM2(SOURCE,TARGET,3*NUMCPW+1) .LT. 0) .AND. (CHRCM2
     X(TARGET,SOURCE,3*NUMCPW+1) .GT. 0)
      RESULT = CHRCM2(SOURCE,TARGET,3*NUMCPW+1)
      IF (.NOT.(RESULT .GE. 0)) GO TO 20015
      OK = .FALSE.
      WRITE (NOUT,10000) RESULT
20015 RESULT = CHRCM2(TARGET,SOURCE,3*NUMCPW+1)
      IF (.NOT.(RESULT .LE. 0)) GO TO 20018
      OK = .FALSE.
      WRITE (NOUT,11000) RESULT
C
C     Test of comparison according to ASCII collating sequence.
C
20018 OK1 = .TRUE.
      ORD =0
      GO TO 20022
20021 ORD =ORD +1
20022 IF ((127-ORD ).LT.0) GO TO 20023
      IF (IN(65,ORD,90) .OR. IN(97,ORD,122)) GO TO 20021
      CHAR1 = CHRLCL(ORD)
      ORD2 =ORD+1
      GO TO 20026
20025 ORD2 =ORD2 +1
20026 IF ((127-ORD2 ).LT.0) GO TO 20027
      IF (IN(65,ORD2,90) .OR. IN(97,ORD2,122)) GO TO 20025
      CHAR2 = CHRLCL(ORD2)
      OK1 = OK1 .AND. (CHRCM2(CHAR1,CHAR2,1) .LT. 0)
     X.AND. (CHRCM2(CHAR2,CHAR1,1) .GT. 0)
      GO TO 20025
20027 GO TO 20021
20023 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,6000)
      OK1 = .TRUE.
      ORD =65
      GO TO 20030
20029 ORD =ORD +1
20030 IF ((89-ORD ).LT.0) GO TO 20031
      CHAR0 = CHRLCL(ORD)
      CTEMP = CHRLCL(ORD+1)
      OK1 = OK1 .AND. (CHRCM2(CHAR0,CTEMP,1) .LT. 0) .AND.
     X(CHRCM2(CTEMP,CHAR0,1) .GT. 0)
      GO TO 20029
20031 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,6000)
      OK1 = .TRUE.
      ORD =32
      GO TO 20034
20033 ORD =ORD +1
20034 IF ((64-ORD ).LT.0) GO TO 20035
      CHAR0 = CHRLCL(ORD)
      OK1 = OK1 .AND. (CHRCM2(CHAR0,'A',1) .LT. 0)
      GO TO 20033
20035 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,6000)
      OK1 = .TRUE.
      ORD =65
      GO TO 20038
20037 ORD =ORD +1
20038 IF ((90-ORD ).LT.0) GO TO 20039
      CHAR0 = CHRLCL(ORD)
      CTEMP = CHRLCL(ORD+32)
      OK1 = OK1 .AND. (CHRCM2(CHAR0,CTEMP,1) .EQ. 0)
      GO TO 20037
20039 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,7000)
      IF (.NOT.(OK)) GO TO 20041
      WRITE (NOUT,2000)
      GO TO 20042
20041 WRITE (NOUT,1000)
20042 COMPA2 = OK
C
      RETURN
C
 1000 FORMAT (' CHRCM2 test FAILED.'//)
 2000 FORMAT (' CHRCM2 test OK.'//)
 3000 FORMAT (' CHRCM2 FAILURE - Equal strings not equal.'//)
 4000 FORMAT (' CHRCM2 FAILURE - Equal strings (apart from',
     X' case differences) not equal.'//)
 6000 FORMAT (' CHRCM2 FAILURE - ASCII ordering not obeyed.'//)
 7000 FORMAT (' CHRCM2 FAILURE - Case difference not ignored.'//)
 8000 FORMAT (' CHRCM2 FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN0) ',3I5/
     X' Output (LOC1,LOC2,LEN0) ',3I5//)
 9000 FORMAT (' CHRCM2 FAILURE - Null-string result must be 0.'//)
10000 FORMAT (' CHRCM2 FAILURE - Strings less than tested as ', I3)
11000 FORMAT (' CHRCM2 FAILURE - Strings greater than tested as ', I3)
C
      END
      LOGICAL FUNCTION  COMPAR (SOURCE,TARGET,MAXBUF,NUMCPW,NOUT)
C     (CHRCMP Test)
C     Requires correct CHRLCL
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AFILL,       CHRCMP,      CHRLCL,      LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRLCL
      INTEGER             CHRCMP
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CH,          CTEMP,       LEN1,        LOC
C     SETS                LOC1,        LOC2,        OK
C     SETS                OK1,         ORD
C
      CHARACTER           CH,          CTEMP,       SOURCE(*)
      CHARACTER           TARGET(*)
      INTEGER             LEN0,        LEN1
      INTEGER             LOC,         LOC1,        LOC2,        MAXBUF
      INTEGER             NOUT,        NUMCPW,      ORD
      INTEGER             RESULT
      LOGICAL             OK,          OK1
C
      OK = .TRUE.
      OK1 = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL LETTER (SOURCE,LOC,LEN0)
      CALL LETTER (TARGET,LOC,LEN0)
      LOC1 = LOC
      LOC2 = LOC
      LEN1 = LEN0
      OK1 = OK1 .AND. (CHRCMP(SOURCE(LOC1),TARGET(LOC2),LEN1) .EQ.
     X0)
      IF (.NOT.((LOC1 .NE. LOC) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLEN0) )) GO TO 20005
      OK1 = .FALSE.
      WRITE (NOUT,6000) LOC,LOC,LEN0,LOC1,LOC2,LEN1
20005 IF (.NOT.(CHRCMP(SOURCE(LOC),TARGET(LOC),0) .NE. 0)) GO TO 20008
      OK = .FALSE.
      WRITE (NOUT,7000)
20008 GO TO 20001
20003 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,2000)
C
C     Inequality tests.
C
      CALL AFILL (SOURCE,MAXBUF,'A')
      CALL AFILL (TARGET,MAXBUF,'Z')
      RESULT = CHRCMP(SOURCE,TARGET,3*NUMCPW+1)
      IF (.NOT.(RESULT .GE. 0)) GO TO 20011
      OK = .FALSE.
      WRITE (NOUT,8000) RESULT
20011 RESULT = CHRCMP(TARGET,SOURCE,3*NUMCPW+1)
      IF (.NOT.(RESULT .LE. 0)) GO TO 20014
      OK = .FALSE.
      WRITE (NOUT,9000) RESULT
20014 OK = OK .AND. OK1
C
C     Test of comparison according to ASCII collating sequence.
C
      OK1 = .TRUE.
      ORD =0
      GO TO 20018
20017 ORD =ORD +1
20018 IF ((126-ORD ).LT.0) GO TO 20019
      CH = CHRLCL(ORD)
      CTEMP = CHRLCL(ORD+1)
      OK1 = OK1 .AND. (CHRCMP(CH,CTEMP,1) .LT. 0)
     X.AND. (CHRCMP(CTEMP,CH,1) .GT. 0)
     X.AND. (CHRCMP(CH,CH,1) .EQ. 0)
      GO TO 20017
20019 OK = OK .AND. OK1
      IF (.NOT.OK1) WRITE (NOUT,4000)
      IF (.NOT.(OK)) GO TO 20021
      WRITE (NOUT,5000)
      GO TO 20022
20021 WRITE (NOUT,1000)
20022 COMPAR = OK
C
      RETURN
C
 1000 FORMAT (' CHRCMP test FAILED.'//)
 2000 FORMAT (' CHRCMP FAILURE - Equal strings not equal.'//)
 4000 FORMAT (' CHRCMP FAILURE - ASCII ordering not obeyed.'//)
 5000 FORMAT (' CHRCMP test OK.'//)
 6000 FORMAT (' CHRCMP FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN0)' ,3I5/
     X' Output (LOC1,LOC2,LEN0)' ,3I5//)
 7000 FORMAT (' CHRCMP FAILURE - Null-string result must be 0.'//)
 8000 FORMAT (' CHRCMP FAILURE - String that was less tested as' ,I3)
 9000 FORMAT (' CHRCMP FAILURE - String that was greater tested as',I3)
C
      END
      LOGICAL FUNCTION  EQUAL (A,LOCA,B,LOCB,LENGTH)
C     (Equal)
C     Return .TRUE. if the  string in A(*)  beginning at LOCA  is
C     equal to  that  in  B(*) beginning  at  LOCB,  and  .FALSE.
C     otherwise.
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                OFFSET
C
      CHARACTER           A(*),        B(*)
      INTEGER             LENGTH,      LOCA,        LOCB,        OFFSET
C
      OFFSET = 0
      GO TO 20002
20001 IF ((OFFSET .GE. LENGTH) .OR. (.NOT.EQUAL)) GO TO 20003
20002 EQUAL = (A(LOCA+OFFSET) .EQ. B(LOCB+OFFSET))
      OFFSET = OFFSET + 1
      GO TO 20001
C
20003 RETURN
      END
      LOGICAL FUNCTION  INDEX2 (TEXT,TEXTUC,NUMCPW,NOUT)
C     (CHRID2 Test)
C     Requires correct CHRCM2, CHRLC, and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCM2,      CHRID2,      LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRLC
      INTEGER             CHRCM2,      CHRID2
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN1,        LOC,         LOC1
C     SETS                LOC2,        LOC3,        OK
C     SETS                TEXT,        TEXTUC
C
      CHARACTER           STRING(80)
      CHARACTER           LETLCZ,      TEXT(*),     TEXTUC(*)
      INTEGER             I,           LENGTH,      LEN1,        LOC
      INTEGER             LOC1,        LOC2,        LOC3,        NOUT
      INTEGER             NUMCPW
      LOGICAL             OK
C
      LETLCZ = CHRLC('Z')
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      TEXT(1) = ' '
      TEXT(2) = ' '
      CALL LETTER (TEXT,LOC,LENGTH)
      CALL LETTER (TEXTUC,LOC,LENGTH)
      I =LOC
      N20005=LOC+LENGTH-1
      GO TO 20006
20005 I =I +1
20006 IF ((N20005-I ).LT.0) GO TO 20007
      TEXT(I) = CHRLC(TEXT(I))
      GO TO 20005
C
20007 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRID2(TEXT,LOC1,TEXTUC(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20009
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20009 IF (.NOT.(I .NE. LOC)) GO TO 20012
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20012 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRID2(TEXTUC,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20015
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20015 IF (.NOT.(I .NE. LOC)) GO TO 20018
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20018 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRID2(TEXT,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20021
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20021 IF (.NOT.(I .NE. LOC)) GO TO 20024
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20024 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRID2(TEXTUC,LOC1,TEXTUC(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20027
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20027 IF (.NOT.(I .NE. LOC)) GO TO 20030
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20030 I = CHRID2(TEXTUC,LENGTH,LETLCZ,1)
      IF (I .GT. 0) OK = OK .AND. (CHRCM2(TEXTUC(I),LETLCZ,1) .EQ.
     X0)
      I = CHRID2(TEXTUC,LENGTH,'1',1)
      OK = OK .AND. (I .EQ. 0)
C
      I = CHRID2(TEXT,LENGTH,'Z',1)
      IF (I .GT. 0) OK = OK .AND. (CHRCM2(TEXT(I),'Z',1) .EQ. 0)
      I = CHRID2(TEXT,LENGTH,'1',1)
      OK = OK .AND. (I .EQ. 0)
C
      IF (.NOT.( (CHRID2(TEXT,LOC1,TEXT(LOC2),0) .NE. 0) .OR.
     X(CHRID2(TEXT,0,TEXT,LOC2) .NE. 0) )) GO TO 20033
      OK = .FALSE.
      WRITE (NOUT,4000)
20033 GO TO 20001
C
C     Test for  correct  finding of  repeated  strings.   Strings
C     shorter than typical  word sizes, and  longer than all  are
C     tested, and checks  are made for  incorrectly looking  past
C     end of string.
C
20003 I =1
      GO TO 20037
20036 I =I +1
20037 IF ((70-I ).LT.0) GO TO 20038
      CALL CHRMOV (STRING,                                            'A
     X.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.',   60
     X)
      LOC1 = CHRID2(STRING(I), 61-I,'A.',2)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 60)) GO TO 20040
      LOC2 = 1 + 2*(I/2)
      GO TO 20041
20040 LOC2 = 0
20041 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,
     X'1234567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRID2(STRING(I),46-I,'1234567890.',11)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 35)) GO TO 20043
      LOC2 = 1 + 11*((I + 9)/11)
      GO TO 20044
20043 LOC2 = 0
20044 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      GO TO 20036
20038 IF (.NOT.(OK)) GO TO 20046
      WRITE (NOUT,2000)
      GO TO 20047
20046 WRITE (NOUT,1000)
20047 INDEX2 = OK
C
      RETURN
C
 1000 FORMAT (' CHRID2 test FAILED.'//)
 2000 FORMAT (' CHRID2 test OK.'//)
 3000 FORMAT (' CHRID2 FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRID2 FAILURE - Null-string result must be 0.'//)
 5000 FORMAT (' CHRID2 - Returned ', I3, ' should have been', I3)
 6000 FORMAT (' CHRID2 - Repeated string failure - Returned ',I3,
     X' should have been' , I3)
C
      END
      LOGICAL FUNCTION  INDEXC (TEXT,NUMCPW,NOUT)
C     (CHRIDX Test)
C     Requires correct CHRCMP and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCMP,      CHRIDX,      LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRCMP,      CHRIDX
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN1,        LOC,         LOC1
C     SETS                LOC2,        LOC3,        OK
C     SETS                TEXT
C
      CHARACTER           STRING(80),  TEXT(*)
      INTEGER             I,           LEN0,         LEN1,        LOC
      INTEGER             LOC1,        LOC2,         LOC3
      INTEGER             NOUT,        NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      TEXT(1) = ' '
      TEXT(2) = ' '
      CALL LETTER (TEXT,LOC,LEN0)
      LOC1 = LEN0 + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LEN0
      I = CHRIDX(TEXT,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLEN0))) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LEN0,LOC1,LOC2,LEN1
20005 IF (.NOT.(I .NE. LOC)) GO TO 20008
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
20008 I = CHRIDX(TEXT,LEN0,'Z',1)
      IF (I .GT. 0) OK = OK .AND. (CHRCMP(TEXT(I),'Z',1) .EQ. 0)
      I = CHRIDX(TEXT,LEN0,'1',1)
      OK = OK .AND. (I .EQ. 0)
      IF (.NOT.(CHRIDX(TEXT,LOC1,TEXT(LOC2),0) .NE. 0)) GO TO 20011
      OK = .FALSE.
      WRITE (NOUT,4000)
20011 GO TO 20001
C
C     Test for  correct  finding of  repeated  strings.   Strings
C     shorter than typical  word sizes, and  longer than all  are
C     tested, and checks  are made for  incorrectly looking  past
C     end of string.
C
20003 I =1
      GO TO 20015
20014 I =I +1
20015 IF ((70-I ).LT.0) GO TO 20016
      CALL CHRMOV (STRING,                                         'A.A.
     XA.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.',60)
      LOC1 = CHRIDX(STRING(I), 61-I,'A.',2)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 60)) GO TO 20018
      LOC2 = 1 + 2*(I/2)
      GO TO 20019
20018 LOC2 = 0
20019 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,                                         '1234
     X567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRIDX(STRING(I),46-I,'1234567890.',11)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 35)) GO TO 20021
      LOC2 = 1 + 11*((I + 9)/11)
      GO TO 20022
20021 LOC2 = 0
20022 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      GO TO 20014
20016 IF (.NOT.(OK)) GO TO 20024
      WRITE (NOUT,2000)
      GO TO 20025
20024 WRITE (NOUT,1000)
20025 INDEXC = OK
C
      RETURN
C
 1000 FORMAT (' CHRIDX test FAILED.'//)
 2000 FORMAT (' CHRIDX test OK.'//)
 3000 FORMAT (' CHRIDX FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRIDX FAILURE - Null-string result must be 0.'//)
 5000 FORMAT (' CHRIDX - Returned ', I3, ' should have been' , I3)
 6000 FORMAT (' CHRIDX - Repeated string failure - Returned ',I3,
     X' should have been' , I3)
C
      END
      SUBROUTINE  CHRTST (NIN,NOUT)
C     (CHRXXX Test)
C     Test the character  primitives for correct  implementation.
C     No  input  is   required,  and  each   test  is   generated
C     automatically.  Output  will consist  of the  name of  each
C     routine followed by the words  'Test OK' or 'Test  FAILED'.
C     In the event of failure, some additional information may be
C     printed to help localize the problem.  The ordering of  the
C     tests  is  important  since  the  correct  functioning   of
C     earlier-tested routines may be required for a test.
C
C     No tests can  be exhaustive,  but the  following tests  are
C     made for each routine:
C     1) Scalar arguments must not be modified; string arguments
C        are not checked for illegal modification.
C     2) Single-argument routines are tested for the entire
C        character set.
C     3) String-argument routines are tested for starting
C        locations of  1,2,...,(number of  characters/word)+1  to
C        check for possible word boundary alignment problems.
C     5) For CHRCMP, CHRCM2, CHRIDX, CHRVFY, and CHRIDX, tests
C        are made  with  patterns  which  would  cause  different
C        results if one too  many or one  too few characters  are
C        examined.
C     6) Tests are made with zero-length strings to ensure that
C        correct results are  returned according  to the  routine
C        specifications.
C
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       ASCLCL,      COMPA2,      COMPAR
C     EXTERNAL REFS       INDEXC,      CHRCHR,      LCUC
C     EXTERNAL REFS       MOVE,        ORDCHR,      SWAP
C     EXTERNAL REFS       VERIFY,      XLATE
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRCHR
      LOGICAL             ASCLCL,      COMPA2,      COMPAR
      LOGICAL             INDEX2
      LOGICAL             INDEXC,      LCUC,        MATCH
      LOGICAL             MOVE,        ORDCHR,      RINDEX,      RINDX2
      LOGICAL             STRLEN,      SWAP,        VERIFY,      XLATE
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     UNUSED              NIN
C
C     SETS                FIRST,       MAXBUF,      MAXCPW,      MAXORD
C     SETS                MAXSZE,      NUMCPW,      OK,          TEXT
C
      CHARACTER           FIRST
      CHARACTER           OLDS(513),   OLDT(513)
      CHARACTER           SOURCE(513), TARGET(513), TEXT(513)
      CHARACTER           TEXTUC(513)
      INTEGER             MAXBUF,      MAXORD,      MAXSZE,      MAXTST
      INTEGER             NIN,         NOUT,        NTEST,       NUMCPW
      LOGICAL             OK
C
      DATA                MAXBUF    / 513 /
      DATA                MAXSZE    / 512 /
      DATA                MAXTST    / 16 /
      DATA                NUMCPW    / 1 /
C
      NTEST = 0
      WRITE (NOUT,1000)
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Determine Host Character Set Size'
      ASSIGN 20001 TO NPR001
      GO TO 30001
20001 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRORD/CHRCHR'
      ASSIGN 20002 TO NPR002
      GO TO 30002
20002 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRLC/CHRUC'
      ASSIGN 20003 TO NPR003
      GO TO 30003
20003 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRASC/CHRLCL'
      ASSIGN 20004 TO NPR004
      GO TO 30004
20004 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRMOV'
      ASSIGN 20005 TO NPR005
      GO TO 30005
20005 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRSWP'
      ASSIGN 20006 TO NPR006
      GO TO 30006
20006 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRCMP'
      ASSIGN 20007 TO NPR007
      GO TO 30007
20007 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRCM2'
      ASSIGN 20008 TO NPR008
      GO TO 30008
20008 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRIDX'
      ASSIGN 20009 TO NPR009
      GO TO 30009
20009 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRID2'
      ASSIGN 20010 TO NPR010
      GO TO 30010
20010 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRLEN'
      ASSIGN 20011 TO NPR011
      GO TO 30011
20011 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRMAT'
      ASSIGN 20012 TO NPR012
      GO TO 30012
20012 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRRIX'
      ASSIGN 20013 TO NPR013
      GO TO 30013
20013 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRRI2'
      ASSIGN 20014 TO NPR014
      GO TO 30014
20014 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRVFY'
      ASSIGN 20015 TO NPR015
      GO TO 30015
20015 WRITE (NOUT,5000) NTEST,MAXTST
C
      NTEST = NTEST + 1
      WRITE (NOUT,4000) NTEST,MAXTST,'Test CHRXLT'
      ASSIGN 20016 TO NPR016
      GO TO 30016
20016 WRITE (NOUT,5000) NTEST,MAXTST
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Determine Host Character Set Size)
30001 FIRST = CHRCHR(0)
      MAXORD = 0
      GO TO 20018
20017 IF ((MAXORD .GT. MAXSZE) .OR. (CHRCHR(MAXORD+1) .EQ.             F
     XIRST)) GO TO 20019
20018 MAXORD = MAXORD + 1
      GO TO 20017
20019 WRITE (NOUT,2000) MAXORD
      IF (.NOT.(MAXORD .GT. MAXSZE)) GO TO 20020
      WRITE (NOUT,3000)
      RETURN
20020 GO TO 20001
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRASC/CHRLCL)
30004 OK = ASCLCL(MAXORD,NOUT)
      GO TO 20004
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRCM2)
30008 OK = COMPA2 (SOURCE,TARGET,MAXBUF,NUMCPW,NOUT)
      GO TO 20008
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRCMP)
30007 OK = COMPAR (SOURCE,TARGET,MAXBUF,NUMCPW,NOUT)
      GO TO 20007
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRID2)
30010 OK = INDEX2 (TEXT,TEXTUC,NUMCPW,NOUT)
      GO TO 20010
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRIDX)
30009 OK = INDEXC (TEXT,NUMCPW,NOUT)
      GO TO 20009
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRLC/CHRUC)
30003 OK = LCUC (MAXORD,NOUT)
      GO TO 20003
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRLEN)
30011 WRITE (NOUT,6000)
      OK = STRLEN (TEXT,TEXTUC,MAXBUF,MAXORD,NOUT)
      GO TO 20011
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRMAT)
30012 OK = MATCH (SOURCE,TARGET,NUMCPW,NOUT)
      GO TO 20012
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRMOV)
30005 OK = MOVE (TEXT,MAXBUF,NUMCPW,NOUT)
      GO TO 20005
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRORD/CHRCHR)
30002 OK = ORDCHR (MAXORD,NOUT)
      IF (.NOT.OK) RETURN
      GO TO 20002
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRRI2)
30014 OK = RINDX2 (TEXT,TEXTUC,NUMCPW,NOUT)
      GO TO 20014
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRRIX)
30013 OK = RINDEX (TEXT,NUMCPW,NOUT)
      GO TO 20013
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRSWP)
30006 OK = SWAP (SOURCE,TARGET,OLDS,OLDT,MAXBUF,NUMCPW,NOUT)
      GO TO 20006
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRVFY)
30015 OK = VERIFY (SOURCE,TARGET,NUMCPW,NOUT)
      GO TO 20015
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Test CHRXLT)
30016 OK = XLATE (SOURCE,TARGET,NUMCPW,NOUT)
      GO TO 20016
C
 1000 FORMAT ('1Test of Machine-Independent FORTRAN',
     X' Character Primitives'//)
 2000 FORMAT (' Host character set has ordinal values 0..',I3//)
 3000 FORMAT (' CHRCHR test FAILED.  Job terminated.'/
     X' Character set size exceeds all known ones.'//)
 4000 FORMAT (//' Begin test ',I3,' of ',I3,' -- ',A)
 5000 FORMAT (' End test   ',I3,' of ',I3)
 6000 FORMAT (' This test takes a long time')
C
      END
      LOGICAL FUNCTION  LCUC (MAXORD,NOUT)
C     (CHRLC/CHRUC Test)
C     Requires correct CHRORD, CHRCHR.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCHR,      CHRLC,       CHRORD,      CHRUC
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRCHR,      CHRLC,       CHRUC
      INTEGER             CHRORD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     STATEMENT FUNCTIONS
C
      LOGICAL             IN
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CH,          GAP,         OK,          ORD
C     SETS                ORDLC,       ORDLCA,      ORDLCZ,      ORDUC
C     SETS                ORDUCA,      ORDUCZ
C
      CHARACTER           CH,          CHLC,        CHUC
      INTEGER             ARG1,        ARG2,        ARG3
      INTEGER             GAP,         MAXORD,      NOUT,        ORD
      INTEGER             ORDLC,       ORDLCA,      ORDLCZ,      ORDUC
      INTEGER             ORDUCA,      ORDUCZ
      LOGICAL             OK
C
      IN(ARG1,ARG2,ARG3) = (ARG1 .LE. ARG2) .AND. (ARG2 .LE. ARG3)
C
      OK = .TRUE.
      ORD =0
      N20001=MAXORD
      GO TO 20002
20001 ORD =ORD +1
20002 IF ((N20001-ORD ).LT.0) GO TO 20003
      CH = 'A'
      IF (.NOT.(CH .NE. 'A')) GO TO 20005
      OK = .FALSE.
      ORDUC = CHRORD(CH)
      ORDLC = CHRORD('A')
      WRITE (NOUT,7000) ORD,ORDLC,ORDUC
20005 GO TO 20001
20003 ORDUCA = CHRORD('A')
      ORDUCZ = CHRORD('Z')
      ORDLCA = CHRORD(CHRLC('A'))
      ORDLCZ = CHRORD(CHRLC('Z'))
      GAP = ORDUCA - ORDLCA
      ORD =0
      N20008=MAXORD
      GO TO 20009
20008 ORD =ORD +1
20009 IF ((N20008-ORD ).LT.0) GO TO 20010
      ORDUC = CHRORD(CHRUC(CHRCHR(ORD)))
      ORDLC = CHRORD(CHRLC(CHRCHR(ORD)))
      IF (.NOT.(IN(ORDUCA,ORD,ORDUCZ))) GO TO 20012
      IF (.NOT.((ORDUC .NE. ORDLC) .AND. (GAP .NE. (ORDUC - ORDLC)))) GO
     XTO 20015
      OK = .FALSE.
      WRITE (NOUT,2000) ORD,ORDUC,ORDLC
20015 GO TO 20013
20012 IF (.NOT.(IN(ORDLCA,ORD,ORDLCZ))) GO TO 10001
      IF (.NOT.((ORDUC .NE. ORDLC) .AND. (GAP .NE. (ORDUC - ORDLC)))) GO
     XTO 20018
      OK = .FALSE.
      WRITE (NOUT,2000) ORD,ORDUC,ORDLC
20018 GO TO 20013
10001 IF (.NOT.(ORDUC .NE. ORDLC)) GO TO 20021
      OK = .FALSE.
      WRITE (NOUT,1000) ORD,ORDUC,ORDLC
20021 CONTINUE
20013 GO TO 20008
20010 ORD =0
      N20024=MAXORD
      GO TO 20025
20024 ORD =ORD +1
20025 IF ((N20024-ORD ).LT.0) GO TO 20026
      CHUC = CHRUC(CHRLC(CHRCHR(ORD)))
      CHLC = CHRUC(CHRCHR(ORD))
      IF (.NOT.(CHUC .NE. CHLC)) GO TO 20028
      OK = .FALSE.
      WRITE (NOUT,3000) ORD,CHRORD(CHUC),CHRORD(CHLC)
20028 CHLC = CHRLC(CHRUC(CHRCHR(ORD)))
      CHUC = CHRLC(CHRCHR(ORD))
      IF (.NOT.(CHUC .NE. CHLC)) GO TO 20031
      OK = .FALSE.
      WRITE (NOUT,4000) ORD,CHRORD(CHUC),CHRORD(CHLC)
20031 GO TO 20024
20026 IF (.NOT.(OK)) GO TO 20034
      WRITE (NOUT,6000)
      GO TO 20035
20034 WRITE (NOUT,5000)
20035 LCUC = OK
C
      RETURN
C
 1000 FORMAT (
     X' CHRUC/CHRLC FAILURE - Different results for non-letter' ,
     X'.  ORD = ',I4,', ORDUC = ',I4,', ORDLC = ',I4//)
 2000 FORMAT (' CHRUC/CHRLC FAILURE - Non-constant gap between upper',
     X' and lower case letters.'/
     X' ORD = ',I4,', ORDUC = ',I4,     ', ORDLC = ',I4//)
 3000 FORMAT (' CHRUC FAILURE - CHRUC(char) .NE. CHRUC(CHRLC(char))',
     X3I5//)
 4000 FORMAT (' CHRLC FAILURE - CHRLC(char) .NE. CHRLC(CHRUC(char))',
     X3I5//)
 5000 FORMAT (' CHRUC/CHRLC test FAILED.'//)
 6000 FORMAT (' CHRUC/CHRLC test OK.'//)
 7000 FORMAT (' **ERROR** ',' CHRUC argument changed at ORD = ',I3/
     X' Input  CHRORD(CHAR) = ',I3/ ' Output CHRORD(CHAR) = ',I3//)
 8000 FORMAT (' **ERROR** ',' CHRLC argument changed at ORD = ',I3/
     X' Input  CHRORD(CHAR) = ',I3/ ' Output CHRORD(CHAR) = ',I3//)
C
      END
      SUBROUTINE  LETTER (TEXT,LOC,LENGTH)
C     (Letter)
C     Fill  text  with  characters  in  range  A..Z  starting  at
C     position LOC, returning in LENGTH the number of  characters
C     stored.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCHR,      CHRORD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRCHR
      INTEGER             CHRORD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                LENGTH,      ORD,         ORDUCA
C     SETS                ORDUCZ
C
      CHARACTER           TEXT(*)
      INTEGER             LENGTH,      LOC,         ORD
      INTEGER             ORDUCA,      ORDUCZ
C
      ORDUCA = CHRORD('A')
      ORDUCZ = CHRORD('Z')
      LENGTH = 0
      ORD =ORDUCA
      N20001=ORDUCZ
      GO TO 20002
20001 ORD =ORD +1
20002 IF ((N20001-ORD ).LT.0) GO TO 20003
      TEXT(LOC+LENGTH) = CHRCHR(ORD)
      LENGTH = LENGTH + 1
      GO TO 20001
C
20003 RETURN
      END
      LOGICAL FUNCTION  MATCH (SOURCE,PATERN,NUMCPW,NOUT)
C     (CHRMAT Test)
C     Requires correct CHRMOV and CHRCMP.
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCMP,      CHRMOV,      CHRMAT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRCMP,      CHRMAT
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                EXPECT,      I,           K,           LENP1
C     SETS                LENP2,       LENS1,       LENS2,       LOC
C     SETS                LOCP1,       LOCP2,       LOCS1,       LOCS2
C     SETS                OK
C
      CHARACTER           PATERN(*),   SOURCE(*),   TEMP(80)
      INTEGER             EXPECT,      I,           K,           LENP1
      INTEGER             LENP2,       LENS1,       LENS2,       LOC
      INTEGER             LOCP1,       LOCP2,       LOCS1,       LOCS2
      INTEGER             NOUT,        NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL CHRMOV (SOURCE(LOC),
     X'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',36)
      LOCS1 = LOC
      LENS1 = 36
      LOCS2 = LOCS1
      LENS2 = LENS1
      LOCP1 = 1
      LENP1 = 4
      LOCP2 = LOCP1
      LENP2 = LENP1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRMAT(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      EXPECT = LOCS2 - 1
      IF (.NOT.((LOCS1 .NE. LOCS2) .OR. (LENS1 .NE. LENS2) .OR. (LOCP1
     X.NE. LOCP2) .OR. (LENP1 .NE. LENP2) .OR. (CHRCMP(
     X'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ',SOURCE(LOC),36)
     X.NE. 0) )) GO TO 20005
      OK = .FALSE.
      CALL CHRMOV (PATERN,SOURCE(LOC),36)
      WRITE (NOUT,2000) LOCS1,LENS1,LOCP1,LENP1, LOCS2,LENS2,
     XLOCP2,LENP2,(PATERN(I),I=1,36)
20005 ASSIGN 20008 TO NPR001
      GO TO 30001
C
20008 LENP2 = 7
      EXPECT = 11 + LOCS2 - 1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRMAT(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20009 TO NPR001
      GO TO 30001
C
20009 LENP2 = 0
      LOCP2 = 1
      EXPECT = LOCS2 - 1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRMAT(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20010 TO NPR001
      GO TO 30001
C
20010 LOCS2 = LOCS1
      LENS2 = 0
      LENP2 = 7
      LOCP2 = 1
      EXPECT = LOCS2 - 1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRMAT(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20011 TO NPR001
      GO TO 30001
C
20011 GO TO 20001
C
20003 LENP2 = 10
      EXPECT = 8
      K = CHRMAT('ABCD + 0.123456789E+00',22,'0123456789-+.E',LENP2)
      ASSIGN 20012 TO NPR001
      GO TO 30001
C
20012 LENP2 = 11
      EXPECT = 8
      K = CHRMAT('ABCD + 0.123456789E+00',22,'.0123456789-+E',LENP2)
      ASSIGN 20013 TO NPR001
      GO TO 30001
C
20013 LENP2 = 12
      EXPECT = 8
      K = CHRMAT('ABCD + 0.123456789E+00',22,'.0123456789E-+',LENP2)
      ASSIGN 20014 TO NPR001
      GO TO 30001
C
20014 LENP2 = 13
      EXPECT = 6
      K = CHRMAT('ABCD + 0.123456789E+00',22,'.0123456789E+-',LENP2)
      ASSIGN 20015 TO NPR001
      GO TO 30001
C
20015 LENP2 = 13
      EXPECT = 6
      K = CHRMAT('ABCD + 0.123456789E-00',22,'.0123456789E+-',LENP2)
      ASSIGN 20016 TO NPR001
      GO TO 30001
C
20016 LENP2 = 14
      EXPECT = 6
      K = CHRMAT('ABCD + 0.123456789E+00',22,'.0123456789E+-',LENP2)
      ASSIGN 20017 TO NPR001
      GO TO 30001
C
20017 I =1
      GO TO 20019
20018 I =I +1
20019 IF ((26-I ).LT.0) GO TO 20020
      EXPECT = 27 - I
      K = CHRMAT('ABCDEFGHIJKLMNOPQRSTUVWXYZ',26,
     X'ZYXWVUTSRQPONMLKJIHGFEDCBA',I)
      ASSIGN 20022 TO NPR001
      GO TO 30001
20022 GO TO 20018
20020 IF (.NOT.(OK)) GO TO 20023
      WRITE (NOUT,4000)
      GO TO 20024
20023 WRITE (NOUT,3000)
20024 MATCH = OK
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check Answer)
30001 IF (.NOT.(K .NE. EXPECT)) GO TO 20026
      OK = .FALSE.
      WRITE (NOUT,1000) K,EXPECT
20026 GO TO NPR001, (20008,20009,20010,20011,20012,20013,20014,20015,200
     X16,20017,20022)
C
 1000 FORMAT (' CHRMAT FAILURE - Returns ',I3,' instead of',I3//)
 2000 FORMAT (' CHRMAT FAILURE - Arguments modified'/
     X' Input  (LOCS,LENS,LOCP,LENP)',4I4/
     X' Output (LOCS,LENS,LOCP,LENP)',4I4/
     X' Input string  ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'/
     X' Output string ',36A1//)
 3000 FORMAT (' CHRMAT test FAILED.'//)
 4000 FORMAT (' CHRMAT test OK.'//)
C
      END
      LOGICAL FUNCTION  MOVE (TEXT,MAXBUF,NUMCPW,NOUT)
C     (CHRMOV Test)
C     Requires correct CHRORD.
C     (04-SEP-87)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AFILL,       ALPHA,       CHRMOV
C     EXTERNAL REFS       LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             ALPHA
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN1,        LOC,         LOC1
C     SETS                LOC2,        OK
C
      CHARACTER           TEXT(*)
      INTEGER             I,           LENGTH,      LEN1
      INTEGER             LOC,         LOC1,        LOC2,        MAXBUF
      INTEGER             NOUT,        NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      CALL AFILL (TEXT,MAXBUF,'ZZZZZZZZZZZZ')
      LOC =2
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL LETTER (TEXT,LOC,LENGTH)
      LOC1 = LOC
      LOC2 = LOC
      LEN1 = LENGTH
      CALL CHRMOV (TEXT(LOC1),TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH) )) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,3000) LOC,LOC,LENGTH,LOC1,LOC2,LEN1
20005 OK = OK .AND. ALPHA(TEXT,LOC)
      CALL LETTER (TEXT,LOC,LENGTH)
      CALL CHRMOV (TEXT(LOC-1),TEXT(LOC),LENGTH)
      OK = OK .AND. ALPHA(TEXT,LOC-1)
C
C          Test right shift.  This  must propagate an  upper-case
C          'A' into all positions.
C
      CALL LETTER (TEXT,LOC,LENGTH)
      CALL CHRMOV (TEXT(LOC+1),TEXT(LOC),LENGTH)
      I =1
      N20008=LENGTH
      GO TO 20009
20008 I =I +1
20009 IF ((N20008-I ).LT.0) GO TO 20010
      OK = OK .AND. (TEXT(LOC+I) .EQ. 'A')
      GO TO 20008
C
C          Test null string moves.
C
20010 CALL LETTER (TEXT,LOC,LENGTH)
      CALL CHRMOV (TEXT(LOC),TEXT,0)
      IF (.NOT.(.NOT.ALPHA(TEXT,LOC))) GO TO 20012
      OK = .FALSE.
      WRITE (NOUT,4000)
20012 GO TO 20001
20003 IF (.NOT.(OK)) GO TO 20015
      WRITE (NOUT,2000)
      GO TO 20016
20015 WRITE (NOUT,1000)
20016 MOVE = OK
C
      RETURN
C
 1000 FORMAT (' CHRMOV test FAILED.'//)
 2000 FORMAT (' CHRMOV test OK.'//)
 3000 FORMAT (' CHRMOV FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRMOV FAILURE - Null-string result must be NO-OP.'//)
C
      END
      LOGICAL FUNCTION  ORDCHR (MAXORD,NOUT)
C     (CHRORD/CHRCHR Test)
C     Requires no other CHRxxx primitives.
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCHR,      CHRORD
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRCHR
      INTEGER             CHRORD
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CH,          CTEMP
C     SETS                OK,          ORD,         OTEMP
C
      CHARACTER           CH,          CTEMP
      INTEGER             MAXORD,      NOUT,        ORD,         OTEMP
      LOGICAL             OK
C
      OK = .TRUE.
      ORD =0
      N20001=MAXORD
      GO TO 20002
20001 ORD =ORD +1
20002 IF ((N20001-ORD ).LT.0) GO TO 20003
      CH = CHRCHR(ORD)
      IF (.NOT.(ORD .NE. CHRORD(CH))) GO TO 20005
      WRITE (NOUT,1000) ORD,ORD
      OK = .FALSE.
20005 GO TO 20001
C
20003 ORD =0
      N20008=MAXORD
      GO TO 20009
20008 ORD =ORD +1
20009 IF ((N20008-ORD ).LT.0) GO TO 20010
      OTEMP = ORD
      CH = CHRCHR(OTEMP)
      IF (.NOT.(OTEMP .NE. ORD)) GO TO 20012
      OK = .FALSE.
      WRITE (NOUT,4000) ORD,OTEMP
20012 CTEMP = CH
      OTEMP = CHRORD(CTEMP)
      IF (.NOT.(CTEMP .NE. CH)) GO TO 20015
      OK = .FALSE.
      WRITE (NOUT,5000) ORD,OTEMP
20015 GO TO 20008
20010 IF (.NOT.(OK)) GO TO 20018
      WRITE (NOUT,2000)
      GO TO 20019
20018 WRITE (NOUT,3000)
20019 ORDCHR = OK
C
      RETURN
C
 1000 FORMAT (' CHRCHR/CHRORD test FAILED - CHRORD(CHRCHR(',I3,
     X')) .NE. ',I3//)
 2000 FORMAT (' CHRCHR/CHRORD test OK'//)
 3000 FORMAT (' CHRCHR/CHRORD test FAILED.  Job terminated.'//)
 4000 FORMAT (' CHRCHR FAILURE - Argument changed'/
     X' Input  (ORD) = ',I4/ ' Output (ORD) = ',I4//)
 5000 FORMAT (' CHRORD FAILURE - Argument changed'/
     X' Input  (CHRORD(CHAR)) = ',I4/
     X' Output (CHRORD(CHAR)) = ',I4//)
C
      END
      LOGICAL FUNCTION  RINDX2 (TEXT,TEXTUC,NUMCPW,NOUT)
C     (CHRRI2 Test)
C     Requires correct CHRCM2, CHRLC, and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCM2,      CHRRI2,      LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      CHARACTER           CHRLC
      INTEGER             CHRCM2,      CHRRI2
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN1,        LOC,         LOC1
C     SETS                LOC2,        LOC3,        OK
C     SETS                TEXT,        TEXTUC
C
      CHARACTER           STRING(80)
      CHARACTER           LETLCZ,      TEXT(*),     TEXTUC(*)
      INTEGER             I,           LENGTH,      LEN1,        LOC
      INTEGER             LOC1,        LOC2,        LOC3,        NOUT
      INTEGER             NUMCPW
      LOGICAL             OK
C
      LETLCZ = CHRLC('Z')
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      TEXT(1) = ' '
      TEXT(2) = ' '
      CALL LETTER (TEXT,LOC,LENGTH)
      CALL LETTER (TEXTUC,LOC,LENGTH)
      I =LOC
      N20005=LOC+LENGTH-1
      GO TO 20006
20005 I =I +1
20006 IF ((N20005-I ).LT.0) GO TO 20007
      TEXT(I) = CHRLC(TEXT(I))
      GO TO 20005
C
20007 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRRI2(TEXT,LOC1,TEXTUC(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20009
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20009 IF (.NOT.(I .NE. LOC)) GO TO 20012
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20012 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRRI2(TEXTUC,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20015
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20015 IF (.NOT.(I .NE. LOC)) GO TO 20018
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20018 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRRI2(TEXT,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20021
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20021 IF (.NOT.(I .NE. LOC)) GO TO 20024
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20024 LOC1 = LENGTH + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LENGTH
      I = CHRRI2(TEXTUC,LOC1,TEXTUC(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH))) GO TO 20027
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LENGTH,LOC1,LOC2,LEN1
20027 IF (.NOT.(I .NE. LOC)) GO TO 20030
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
C
20030 I = CHRRI2(TEXTUC,LENGTH,LETLCZ,1)
      IF (I .GT. 0) OK = OK .AND. (CHRCM2(TEXTUC(I),LETLCZ,1) .EQ.
     X0)
      I = CHRRI2(TEXTUC,LENGTH,'1',1)
      OK = OK .AND. (I .EQ. 0)
C
      I = CHRRI2(TEXT,LENGTH,'Z',1)
      IF (I .GT. 0) OK = OK .AND. (CHRCM2(TEXT(I),'Z',1) .EQ. 0)
      I = CHRRI2(TEXT,LENGTH,'1',1)
      OK = OK .AND. (I .EQ. 0)
C
      IF (.NOT.( (CHRRI2(TEXT,LOC1,TEXT(LOC2),0) .NE. 0) .OR.
     X(CHRRI2(TEXT,0,TEXT,LOC2) .NE. 0) )) GO TO 20033
      OK = .FALSE.
      WRITE (NOUT,4000)
20033 GO TO 20001
C
C     Test for  correct  finding of  repeated  strings.   Strings
C     shorter than typical  word sizes, and  longer than all  are
C     tested, and checks  are made for  incorrectly looking  past
C     end of string.
C
20003 I =1
      GO TO 20037
20036 I =I +1
20037 IF ((70-I ).LT.0) GO TO 20038
      CALL CHRMOV (STRING,                                            'A
     X.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.',   60
     X)
      LOC1 = CHRRI2(STRING(I), 61-I,'A.',2)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 60)) GO TO 20040
      LOC2 = 59
      GO TO 20041
20040 LOC2 = 0
20041 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,
     X'1234567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRRI2(STRING(I),46-I,'1234567890.',11)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 35)) GO TO 20043
      LOC2 = 34
      GO TO 20044
20043 LOC2 = 0
20044 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,
     X'1234567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRRI2(STRING,46-I,'1234567890.',11)
      IF (.NOT.(I .LE. 35)) GO TO 20046
      LOC2 = 1 + 11*((35 - I)/11)
      GO TO 20047
20046 LOC2 = 0
20047 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      GO TO 20036
20038 IF (.NOT.(OK)) GO TO 20049
      WRITE (NOUT,2000)
      GO TO 20050
20049 WRITE (NOUT,1000)
20050 RINDX2 = OK
C
      RETURN
C
 1000 FORMAT (' CHRRI2 test FAILED.'//)
 2000 FORMAT (' CHRRI2 test OK.'//)
 3000 FORMAT (' CHRRI2 FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRRI2 FAILURE - Null-string result must be 0.'//)
 5000 FORMAT (' CHRRI2 - Returned ', I3, ' should have been', I3)
 6000 FORMAT (' CHRRI2 - Repeated string failure - Returned ',I3,
     X' should have been' , I3)
C
      END
      LOGICAL FUNCTION  RINDEX (TEXT,NUMCPW,NOUT)
C     (CHRRIX Test)
C     Requires correct CHRCMP and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCMP,      CHRRIX,      LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRCMP,      CHRRIX
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN1,        LOC,         LOC1
C     SETS                LOC2,        LOC3,        OK
C     SETS                TEXT
C
      CHARACTER           STRING(80),  TEXT(*)
      INTEGER             I,           LEN0,         LEN1,        LOC
      INTEGER             LOC1,        LOC2,         LOC3,        NOUT
      INTEGER             NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      TEXT(1) = ' '
      TEXT(2) = ' '
      CALL LETTER (TEXT,LOC,LEN0)
      LOC1 = LEN0 + LOC - 1
      LOC3 = LOC1
      LOC2 = LOC
      LEN1 = LEN0
      I = CHRRIX(TEXT,LOC1,TEXT(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC3) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLEN0))) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,3000) LOC3,LOC,LEN0,LOC1,LOC2,LEN1
20005 IF (.NOT.(I .NE. LOC)) GO TO 20008
      OK = .FALSE.
      WRITE (NOUT, 5000) I, LOC
20008 I = CHRRIX(TEXT,LEN0,'Z',1)
      IF (I .GT. 0) OK = OK .AND. (CHRCMP(TEXT(I),'Z',1) .EQ. 0)
      I = CHRRIX(TEXT,LEN0,'1',1)
      OK = OK .AND. (I .EQ. 0)
      IF (.NOT.(CHRRIX(TEXT,LOC1,TEXT(LOC2),0) .NE. 0)) GO TO 20011
      OK = .FALSE.
      WRITE (NOUT,4000)
20011 GO TO 20001
C
C     Test for  correct  finding of  repeated  strings.   Strings
C     shorter than typical  word sizes, and  longer than all  are
C     tested, and checks  are made for  incorrectly looking  past
C     end of string.
C
20003 I =1
      GO TO 20015
20014 I =I +1
20015 IF ((70-I ).LT.0) GO TO 20016
      CALL CHRMOV (STRING,                                         'A.A.
     XA.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.A.',60)
      LOC1 = CHRRIX(STRING(I), 61-I,'A.',2)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 60)) GO TO 20018
      LOC2 = 59
      GO TO 20019
20018 LOC2 = 0
20019 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,                                         '1234
     X567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRRIX(STRING(I),46-I,'1234567890.',11)
      IF (LOC1 .GT. 0) LOC1 = LOC1 + I - 1
      IF (.NOT.(I .LT. 35)) GO TO 20021
      LOC2 = 34
      GO TO 20022
20021 LOC2 = 0
20022 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      CALL CHRMOV (STRING,                                         '1234
     X567890.1234567890.1234567890.1234567890.1234567890.',50)
      LOC1 = CHRRIX(STRING,46-I,'1234567890.',11)
      IF (.NOT.(I .LE. 35)) GO TO 20024
      LOC2 = 1 + 11*((35 - I)/11)
      GO TO 20025
20024 LOC2 = 0
20025 OK = OK .AND. (LOC1 .EQ. LOC2)
      IF (LOC1 .NE. LOC2) WRITE (NOUT,6000) LOC1,LOC2
      GO TO 20014
20016 IF (.NOT.(OK)) GO TO 20027
      WRITE (NOUT,2000)
      GO TO 20028
20027 WRITE (NOUT,1000)
20028 RINDEX = OK
C
      RETURN
C
 1000 FORMAT (' CHRRIX test FAILED.'//)
 2000 FORMAT (' CHRRIX test OK.'//)
 3000 FORMAT (' CHRRIX FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRRIX FAILURE - Null-string result must be 0.'//)
 5000 FORMAT (' CHRRIX - Returned ', I3, ' should have been' , I3)
 6000 FORMAT (' CHRRIX - Repeated string failure - Returned ',I3,
     X' should have been' , I3)
C
      END
      LOGICAL FUNCTION  STRLEN (TEXT,TEXTUC,MAXBUF,MAXORD,NOUT)
C     (CHRLEN Test)
C     Requires correct CHRMOV, CHRCMP, CHRORD, CHRCHR.
C     (31-JUL-85)
      CHARACTER           CHRCHR
      INTEGER             CHRORD,      CHRCMP,      CHRLEN
C
      CHARACTER           TEXT(*),     TEXTUC(*)
      INTEGER             EXPECT,      K,           L,           M
      INTEGER             MAXBUF,      MAXORD,      NOUT
      LOGICAL             OK
C
      OK = .TRUE.
C
C     First test: check for argument modification.
C
      TEXT(1) = ' '
      CALL CHRMOV (TEXT(2),TEXT(1),MAXBUF-1)
      CALL CHRMOV (TEXTUC,TEXT,MAXBUF)
      K =1
      N20001=MAXBUF
      GO TO 20002
20001 K =K +1
20002 IF ((N20001-K ).LT.0) GO TO 20003
      EXPECT = K
      L = CHRLEN (TEXT,K)
      IF (.NOT.((K .NE. EXPECT) .OR. (CHRCMP(TEXT,TEXTUC,MAXBUF) .NE. 0)
     X)) GO TO 20005
      WRITE (NOUT,1000) K
      OK = .FALSE.
20005 GO TO 20001
C
C     Second test: a completely blank string should give 0.
C
20003 TEXT(1) = ' '
      CALL CHRMOV (TEXT(2),TEXT(1),MAXBUF-1)
      CALL CHRMOV (TEXTUC,TEXT,MAXBUF)
      K =1
      N20008=MAXBUF
      GO TO 20009
20008 K =K +1
20009 IF ((N20008-K ).LT.0) GO TO 20010
      EXPECT = 0
      L = CHRLEN (TEXT,K)
      IF (.NOT.(L .NE. EXPECT)) GO TO 20012
      WRITE (NOUT,2000) L,K
      OK = .FALSE.
20012 GO TO 20008
C
C     Third test: a non-blank in position K should give K.
C
20010 TEXT(1) = ' '
      CALL CHRMOV (TEXT(2),TEXT(1),MAXBUF-1)
      K =1
      N20015=MAXBUF
      GO TO 20016
20015 K =K +1
20016 IF ((N20015-K ).LT.0) GO TO 20017
      TEXT(K) = 'X'
      EXPECT = K
      L = CHRLEN (TEXT,MAXBUF)
      TEXT(K) = ' '
      IF (.NOT.(L .NE. EXPECT)) GO TO 20019
      WRITE (NOUT,3000) L,K
      OK = .FALSE.
20019 GO TO 20015
C
C     Fourth test: a non-blank outside of the string should still
C     give 0.
C
20017 TEXT(1) = ' '
      CALL CHRMOV (TEXT(2),TEXT(1),MAXBUF-1)
      TEXT(MAXBUF) = 'X'
      K =2
      N20022=MAXBUF-1
      GO TO 20023
20022 K =K +1
20023 IF ((N20022-K ).LT.0) GO TO 20024
      TEXT(K-1) = 'X'
      EXPECT = 0
      L = CHRLEN (TEXT(K),MAXBUF-K)
      IF (.NOT.(L .NE. EXPECT)) GO TO 20026
      WRITE (NOUT,4000) L,MAXBUF-K
      OK = .FALSE.
20026 GO TO 20022
C
C     Fifth test: all  possible non-blanks in  position K  should
C     give K.   This  test  takes  rather a  long  time,  but  is
C     essential for completeness.
C
20024 TEXT(1) = ' '
      CALL CHRMOV (TEXT(2),TEXT(1),MAXBUF-1)
      K =1
      GO TO 20030
20029 K =K +1
20030 IF ((11-K ).LT.0) GO TO 20031
      M =0
      N20033=MAXORD
      GO TO 20034
20033 M =M +1
20034 IF ((N20033-M ).LT.0) GO TO 20035
      IF (.NOT.(CHRORD(' ') .NE. M)) GO TO 20037
      TEXT(K) = CHRCHR(M)
      EXPECT = K
      L = CHRLEN (TEXT,MAXBUF)
      TEXT(K) = ' '
      IF (.NOT.(L .NE. EXPECT)) GO TO 20040
      WRITE (NOUT,5000) L,K,M
      OK = .FALSE.
20040 CONTINUE
20041 CONTINUE
20037 GO TO 20033
20035 GO TO 20029
C
20031 IF (.NOT.(OK)) GO TO 20043
      WRITE (NOUT,6000)
      GO TO 20044
20043 WRITE (NOUT,7000)
20044 STRLEN = OK
C
      RETURN
C
 1000 FORMAT (' CHRLEN failure - argument modification for',
     X' string of length ',I3)
 2000 FORMAT (' CHRLEN failure - returned ',I3,
     X' instead of 0 for blank string of length ',I3)
 3000 FORMAT (' CHRLEN failure - returned ',I3,' should have been ',I3/
     X18X,'for non-blank in that position')
 4000 FORMAT (' CHRLEN failure - returned ',I3,
     X' instead of 0 for blank substring of length ',I3/
     X18X,'inside a non-blank string')
 5000 FORMAT (' CHRLEN failure -- returned ',I3,
     X' instead of ',I3,
     X18X,'for character ordinal ',I5,' in that position ')
 6000 FORMAT (' CHRLEN test OK.'//)
 7000 FORMAT (' CHRLEN test FAILED.'//)
      END
      LOGICAL FUNCTION  SWAP (SOURCE,TARGET,OLDS,OLDT,MAXBUF,NUMCPW,
     XNOUT)
C     (CHRSWP Test)
C     Requires no other CHRxxx primitives.
C     (04-APR-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       AFILL,       ALPHA,       EQUAL,       CHRSWP
C     EXTERNAL REFS       LETTER
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      LOGICAL             ALPHA,       EQUAL
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                LEN1,        LOC,         LOC1,        LOC2
C     SETS                OK
C
      CHARACTER           OLDS(*),     OLDT(*),     SOURCE(*)
      CHARACTER           TARGET(*)
      INTEGER             LENGTH,      LEN1,        LOC,         LOC1
      INTEGER             LOC2,        MAXBUF,      NOUT
      INTEGER             NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
C
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL LETTER (SOURCE,LOC,LENGTH)
      CALL LETTER (OLDS  ,LOC,LENGTH)
      CALL AFILL  (TARGET,MAXBUF,'ZZZZZZZZZZZZ')
      CALL AFILL  (OLDT  ,MAXBUF,'ZZZZZZZZZZZZ')
      LOC1 = LOC
      LOC2 = LOC
      LEN1 = LENGTH
      CALL CHRSWP (TARGET(LOC1),SOURCE(LOC2),LEN1)
      IF (.NOT.((LOC1 .NE. LOC) .OR. (LOC2 .NE. LOC) .OR. (LEN1 .NE.
     XLENGTH) )) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,3000) LOC,LOC,LENGTH,LOC1,LOC2,LEN1
20005 IF (.NOT.(.NOT. EQUAL(TARGET,LOC,OLDS,LOC,LENGTH))) GO TO 20008
      OK = .FALSE.
      WRITE (NOUT,5000)
20008 IF (.NOT.(.NOT. EQUAL(SOURCE,LOC,OLDT,LOC,LENGTH))) GO TO 20011
      OK = .FALSE.
      WRITE (NOUT,6000)
20011 CALL LETTER (SOURCE,LOC,LENGTH)
      CALL AFILL  (TARGET,MAXBUF,'ZZZZZZZZZZZZ')
      CALL CHRSWP (SOURCE(LOC),TARGET(LOC),0)
      IF (.NOT.(.NOT.ALPHA(SOURCE,LOC))) GO TO 20014
      OK = .FALSE.
      WRITE (NOUT,4000)
20014 GO TO 20001
20003 IF (.NOT.(OK)) GO TO 20017
      WRITE (NOUT,2000)
      GO TO 20018
20017 WRITE (NOUT,1000)
20018 SWAP = OK
C
      RETURN
C
 1000 FORMAT (' CHRSWP test FAILED.'//)
 2000 FORMAT (' CHRSWP test OK.'//)
 3000 FORMAT (' CHRSWP FAILURE - Arguments modified.'/
     X' Input  (LOC1,LOC2,LEN) ',3I5/
     X' Output (LOC1,LOC2,LEN) ',3I5//)
 4000 FORMAT (' CHRSWP FAILURE - Null-string caused argument',
     X' modification.'//)
 5000 FORMAT (' CHRSWP - First string not correctly updated.')
 6000 FORMAT (' CHRSWP - Second string not correctly updated.')
C
      END
      LOGICAL FUNCTION  VERIFY (SOURCE,PATERN,NUMCPW,NOUT)
C     (CHRVFY Test)
C     Requires correct CHRCMP and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCMP,      CHRMOV,      CHRVFY
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRCMP,      CHRVFY
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                EXPECT,      I,           K,           LENP1
C     SETS                LENP2,       LENS1,       LENS2,       LOC
C     SETS                LOCP1,       LOCP2,       LOCS1,       LOCS2
C     SETS                OK
C
      CHARACTER           PATERN(*),   SOURCE(*),   TEMP(80)
      INTEGER             EXPECT,      I,           K,           LENP1
      INTEGER             LENP2,       LENS1,       LENS2,       LOC
      INTEGER             LOCP1,       LOCP2,       LOCS1,       LOCS2
      INTEGER             NOUT,        NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL CHRMOV (SOURCE(LOC),
     X'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',36)
      LOCS1 = LOC
      LENS1 = 36
      LOCS2 = LOCS1
      LENS2 = LENS1
      LOCP1 = 1
      LENP1 = 4
      LOCP2 = LOCP1
      LENP2 = LENP1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRVFY(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      EXPECT = 1 + (LOCS2 - 1)
      IF (.NOT.((LOCS1 .NE. LOCS2) .OR. (LENS1 .NE. LENS2) .OR. (LOCP1
     X.NE. LOCP2) .OR. (LENP1 .NE. LENP2) .OR. (CHRCMP(
     X'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789',SOURCE(LOC),36)
     X.NE. 0) )) GO TO 20005
      OK = .FALSE.
      CALL CHRMOV (PATERN,SOURCE(LOC),36)
      WRITE (NOUT,2000) LOCS1,LENS1,LOCP1,LENP1, LOCS2,LENS2,
     XLOCP2,LENP2,(PATERN(I),I=1,36)
20005 ASSIGN 20008 TO NPR001
      GO TO 30001
C
20008 LENP2 = 7
      EXPECT = 4 + (LOCS2 - 1)
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRVFY(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20009 TO NPR001
      GO TO 30001
C
20009 LENP2 = 0
      LOCP2 = 1
      EXPECT = LOCS2 - 1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRVFY(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20010 TO NPR001
      GO TO 30001
C
20010 LOCS2 = LOCS1
      LENS2 = 0
      LENP2 = 7
      LOCP2 = 1
      EXPECT = LOCS2 - 1
      CALL CHRMOV (TEMP,'.,()ABC',7)
      K = CHRVFY(SOURCE(LOCS2),LENS2,TEMP(LOCP2),LENP2) + LOCS2 - 1
      ASSIGN 20011 TO NPR001
      GO TO 30001
C
20011 GO TO 20001
C
20003 LENP2 = 10
      EXPECT = 2
      K = CHRVFY('0.123456789E+00',15,'0123456789-+.E',LENP2)
      ASSIGN 20012 TO NPR001
      GO TO 30001
C
20012 LENP2 = 11
      EXPECT = 12
      K = CHRVFY('0.123456789E+00',15,'.0123456789-+E',LENP2)
      ASSIGN 20013 TO NPR001
      GO TO 30001
C
20013 LENP2 = 12
      EXPECT = 13
      K = CHRVFY('0.123456789E+00',15,'.0123456789E-+',LENP2)
      ASSIGN 20014 TO NPR001
      GO TO 30001
C
20014 LENP2 = 13
      EXPECT = 0
      K = CHRVFY('0.123456789E+00',15,'.0123456789E+-',LENP2)
      ASSIGN 20015 TO NPR001
      GO TO 30001
C
20015 LENP2 = 13
      EXPECT = 13
      K = CHRVFY('0.123456789E-00',15,'.0123456789E+-',LENP2)
      ASSIGN 20016 TO NPR001
      GO TO 30001
C
20016 LENP2 = 14
      EXPECT = 0
      K = CHRVFY('0.123456789E+00',15,'.0123456789E+-',LENP2)
      ASSIGN 20017 TO NPR001
      GO TO 30001
C
20017 IF (.NOT.(OK)) GO TO 20018
      WRITE (NOUT,4000)
      GO TO 20019
20018 WRITE (NOUT,3000)
20019 VERIFY = OK
C
      RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check Answer)
30001 IF (.NOT.(K .NE. EXPECT)) GO TO 20021
      OK = .FALSE.
      WRITE (NOUT,1000) K,EXPECT
20021 GO TO NPR001, (20008,20009,20010,20011,20012,20013,20014,20015,200
     X16,20017)
C
 1000 FORMAT (' CHRVFY FAILURE - Returns ',I3,' instead of',I3//)
 2000 FORMAT (' CHRVFY FAILURE - Arguments modified'/
     X' Input  (LOCS,LENS,LOCP,LENP)',4I4/
     X' Output (LOCS,LENS,LOCP,LENP)',4I4/
     X' Input string  ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789'/
     X' Output string ',36A1//)
 3000 FORMAT (' CHRVFY test FAILED.'//)
 4000 FORMAT (' CHRVFY test OK.'//)
C
      END
      LOGICAL FUNCTION  XLATE (SOURCE,TARGET,NUMCPW,NOUT)
C     (CHRXLT Test)
C     Requires correct CHRCMP and CHRMOV.
C     (31-JUL-85)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C           EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHRCMP,      CHRMOV,      CHRXLT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHRCMP
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                I,           LEN0,        LEN1,        LEN2
C     SETS                LOC,         LOC0,        LOC1,        LOC2
C     SETS                LOC3,        OK
C
      CHARACTER           SOURCE(*),   TARGET(*)
      CHARACTER           NEW(50),     OLD(50),     STRING(50)
      INTEGER             I,           LEN0,        LEN1,        LEN2
      INTEGER             LOC,         LOC0,        LOC1,        LOC2
      INTEGER             LOC3,        NOUT,        NUMCPW
      LOGICAL             OK
C
      OK = .TRUE.
      CALL CHRMOV (TARGET,'ABCDEFGHIJKLMNOPQRSTUVWXYZ',26)
      LOC =1
      N20001=NUMCPW+1
      GO TO 20002
20001 LOC =LOC +1
20002 IF ((N20001-LOC ).LT.0) GO TO 20003
      CALL CHRMOV (SOURCE,TARGET,26)
      LOC1 = LOC
      LOC0 = 1
      LOC2 = 1
      LOC3 = 1
      LEN0 = 27 - LOC
      LEN1 = LEN0
      LEN2 = 10
      CALL CHRMOV (OLD,'ABCDEFGHIJ',10)
      CALL CHRMOV (NEW,'0123456789',10)
      CALL CHRXLT (SOURCE(LOC1),LEN1,OLD(LOC2),NEW(LOC3),LEN2)
      IF (.NOT.((LOC1 .NE. LOC) .OR. (LEN1 .NE. (27-LOC)) .OR. (LOC2
     X.NE. 1) .OR. (LOC3 .NE. 1) .OR. (LEN2 .NE. 10))) GO TO 20005
      OK = .FALSE.
      WRITE (NOUT,5000) LOC,LEN0,LOC0,LOC0,LEN0, LOC1,LEN1,
     XLOC2,LOC3,LEN2
20005 CALL CHRMOV (STRING,'0123456789KLMNOPQRSTUVWXYZ',26)
      IF (.NOT.(CHRCMP(SOURCE(LOC),STRING(LOC),27-LOC) .NE. 0)) GO TO 20
     X008
      OK = .FALSE.
      WRITE (NOUT,1000)
20008 CALL CHRXLT (SOURCE(LOC),27-LOC,'0123456789','ABCDEFGHIJ',10)
      IF (.NOT.(CHRCMP(SOURCE(LOC),TARGET(LOC),27-LOC) .NE. 0)) GO TO 20
     X011
      OK = .FALSE.
      WRITE (NOUT,1000)
20011 GO TO 20001
20003 CALL CHRMOV (SOURCE,TARGET,26)
      CALL CHRXLT (SOURCE,26, 'XXX', 'ABC', 3)
      IF (.NOT.(CHRCMP(SOURCE,'ABCDEFGHIJKLMNOPQRSTUVWCYZ',26) .NE. 0))
     XGO TO 20014
      OK = .FALSE.
      WRITE (NOUT,4000) (SOURCE(I),I=1,26)
C
C     Test for null string arugments.
C
20014 CALL CHRMOV (SOURCE,TARGET,26)
      CALL CHRXLT (SOURCE,26, 'XXX','ABC',0)
      IF (.NOT.(CHRCMP(SOURCE,TARGET,26) .NE. 0)) GO TO 20017
      OK = .FALSE.
      WRITE (NOUT,6000)
20017 CALL CHRMOV (SOURCE,TARGET,26)
      CALL CHRXLT (SOURCE, 0, 'XXX','ABC',3)
      IF (.NOT.(CHRCMP(SOURCE,TARGET,26) .NE. 0)) GO TO 20020
      OK = .FALSE.
      WRITE (NOUT,6000)
20020 IF (.NOT.(OK)) GO TO 20023
      WRITE (NOUT,2000)
      GO TO 20024
20023 WRITE (NOUT,3000)
20024 XLATE = OK
C
      RETURN
C
 1000 FORMAT (' CHRXLT FAILURE - Translation incorrect'//)
 2000 FORMAT (' CHRXLT test OK.'//)
 3000 FORMAT (' CHRXLT test FAILED.'//)
 4000 FORMAT (' CHRXLT FAILURE - Duplicate characters'/
     X' in source pattern handled incorrectly.'/
     X' Source pattern = ''XXX'''/
     X' Target pattern = ''ABC'''/
     X' Input string   = ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
     X' Output string  = ',26A1/
     X' Correct string = ABCDEFGHIJKLMNOPQRSTUVWCYZ'//)
 5000 FORMAT (' CHRXLT FAILURE - Arguments modified.'/
     X' Input  (LOC1,LEN1,LOC2,LOC3,LEN) ',5I5/
     X' Output (LOC1,LEN1,LOC2,LOC3,LEN) ',5I5//)
 6000 FORMAT (' CHRXLT FAILURE - Null-string result must be NO-OP.'//)
      END
