#ifdef _AIX370

/* AIX 370 at present lacks a Fortran-callable iargc() and getarg().
IBM Corporation posted this stopgap solution to some net some time ago. */

#define goodarg(x) ( ( (unsigned int) x ) < 0xfffffffe)

static void
copy_tofort(char *dest, char *source ,int len)
{
    /* copy source (which is a string) and pad with blanks */
    register int j, n;
    extern int strlen(const char * s);

    /* note source is 0 if getenv etc failed */
    if (source)
	n = strlen(source);
    else
        n = 0;
    for (j = 0; j < len; j++)
    {
        if (j < n)
	    *dest++ = *source++;
	else
	    *dest++ = ' ';
    }
}

int
iargc_()
{
    extern int afbxargn;
    return(afbxargn);
}

#if 0
#include <stdio.h>
#endif

void
getarg_(int *pn, char *s, int *plen_n, int *plen_s)
{
    extern int afbxargn;
    extern char **afbxargv;
    char *p;

#if 0
    fprintf(stderr,
	"DEBUG: getarg(): pn = [%d] plen_n = [%d] plen_s = [%d]\n",
	*pn, *plen_n, *plen_s);
    fprintf(stderr,
	"DEBUG: getarg(): argv[0] = [%s] argv[1] = [%s]",
	afbxargv[0], afbxargv[1]);
#endif

    if ( (*pn >= 0) && (*pn <= afbxargn))
	p = afbxargv[*pn];
    else
	p = " ";
    if (goodarg(plen_s))
	copy_tofort(s, p, *plen_s);
}
#endif /* _AIX370 */
