#include "p79.h"

#define MAXBUF		1024		/* fixed buffer for termcap entry */

char	*tgetstr ARGS((char *tc, char **s));
int	tgetent ARGS((char bp[], char* p));

/* return screen clear string in str, and its length as function value */

int
FORTRAN(p79clr,P79CLR)(str, FLENARG(str))
FCHAR	str;
int	FLENARG(str);
{
    char	bp[MAXBUF];
    char	buf[MAXBUF];
    int		n;
    char	*p;
    char	*q;

    (void)memset(&CH(str,0),' ',FLEN(str));
    p = buf;
    if (tgetent(bp,getenv("TERM")) == 1)
    {
	q = tgetstr("cl",&p);	/* p is updated by tgetstr() */
	n = MIN(strlen(q),FLEN(str));
	(void)strncpy(&CH(str,0),q,n);
				/* q, not buf[], contains termcap string */
    }
    else
	n = 0;
    return (n);
}

