      SUBROUTINE  INITHT (PRIME,HASHTB,MAXHTB)
C     (Initialize Hash Table)
C     (30-JUL-79)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       SFTERR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     RUNTIME DIMENSION VARIABLES
C
      INTEGER             MAXHTB
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                HASHTB,      I,           NULL
C
      INTEGER             HASHTB(MAXHTB),           I,           NULL
      INTEGER             PRIME
C
C
C     Element defining a null link  in a list.  Any  non-positive
C     value could be used.
C
      DATA                NULL      / 0 /
C
      IF (.NOT.((PRIME+3) .GT. MAXHTB)) GO TO 20001
      CALL SFTERR (2,21H(Hash table overflow))
20001 CONTINUE
20002 HASHTB(1) = PRIME
      HASHTB(2) = PRIME + 4
      HASHTB(3) = MAXHTB
      I =1
      N20004=PRIME
      GO TO 20005
20004 I =I +1
20005 IF ((N20004-I ).LT.0) GO TO 20006
      HASHTB(I+3) = NULL
      GO TO 20004
C
20006 RETURN
      END
