      LOGICAL FUNCTION  SCANER (IFUNC, STRING, N)
C     (SCANER)
C     (23-OCT-84)
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL REFERENCES (FUNCTION,SUBROUTINE,COMMON)
C
C     EXTERNAL REFS       CHGET3,      F4CLC,       MAX0
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     EXTERNAL FUNCTIONS AND SUBROUTINES
C
      INTEGER             CHGET3
      LOGICAL             F4CLC
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     INTRINSIC FUNCTIONS
C
      INTEGER             MAX0
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     NON-COMMON VARIABLES
C
C     SETS                CCNEXT,      CCSAVE,      GIVEN,       LEVL
C     SETS                MATCH,       NXT,         QUOTED
C
      INTEGER             CCNEXT,      CCSAVE,      GIVEN,       IFUNC
      INTEGER             LEVL,        N,           NXT
      INTEGER             STRING(1)
      LOGICAL             MATCH,       QUOTED
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM01  /
C
      INTEGER             BYTE,        CC,          CCLABL
      INTEGER             CCMORE,      IN,          INDENT
      INTEGER             LLABL,       MLABL
      INTEGER             NHELD,       OUT
      INTEGER             UNDENT
      LOGICAL             EOF,         FIRST,       LABEL,       LAST
      LOGICAL             MORE
C
      COMMON / COM01  /   BYTE,        CC,          CCLABL
      COMMON / COM01  /   CCMORE,      EOF,         FIRST,       IN
      COMMON / COM01  /   INDENT,      LABEL,       LAST
      COMMON / COM01  /   LLABL,       MLABL,       MORE
      COMMON / COM01  /   NHELD
      COMMON / COM01  /   OUT,         UNDENT
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM04  /
C
      INTEGER             ARZ,         BLNKRZ,      COLNRZ,      CRZ
      INTEGER             DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      INTEGER             PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      INTEGER             STARRZ,      ZERORZ,      ZRZ
C
      COMMON / COM04  /   ARZ,         BLNKRZ,      COLNRZ,      CRZ
      COMMON / COM04  /   DASHRZ,      HRZ,         LEFTRZ,      NINERZ
      COMMON / COM04  /   PLUSRZ,      QUOTRZ,      RITERZ,      SLSHRZ
      COMMON / COM04  /   STARRZ,      ZERORZ,      ZRZ
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM11  /
C
      INTEGER             COMCHR,      LCCHR
C
      COMMON / COM11  /   COMCHR(1),   LCCHR
C
C  - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C
C     COMMON BLOCK / COM31  /
C
      INTEGER             NS,          NSMAX,       STMT
C
      COMMON / COM31  /   NS,          NSMAX,       STMT(1326)
C
C
C     Main logic
C
      NX0004=IFUNC
      IF (NX0004.LT.1.OR.NX0004.GT.3) GO TO 20004
      GO TO (20001,20002,20003), NX0004
20001 ASSIGN 20006 TO NPR001
      GO TO 30001
20006 GO TO 20005
20002 ASSIGN 20007 TO NPR002
      GO TO 30002
20007 GO TO 20005
20003 ASSIGN 20008 TO NPR003
      GO TO 30003
20008 CONTINUE
20004 CONTINUE
C
20005 RETURN
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Check for any more Non-Blank Code Characters)
C
C          Given that CCNEXT .LE.  NS, start at STMT[CCNEXT]  and
C          search until either a non-blank is found or the string
C          is exhausted.  If a non-blank  is found and it is  not
C          the inline-comment character, 'MORE'  is set TRUE  and
C          'CCMORE' is its  position.  Otherwise,  'MORE' is  set
C          FALSE and 'NS' is set to the string length.
C
C          Inputs:
C             NS     = length of 'STMT' string
C             CCNEXT = byte of 'STMT' at which to begin search
C                      for non-blank
C
C          Decision Table:
C
C          CCNEXT  .LE. NS                *  F      T       T      T
C          Stmt blank from CCNEXT onward  *         T       F      F
C          1st non-blank is comment char  *                 T      F
C                                         *
C          *************************************************************
C                                         *
C          MORE   . . . . . . . . . . . . * .F.    .F.     .F.    .T.
C          CCMORE = loc of next non-blank * N/C    N/C     N/C   column
C          NS     . . . . . . . . . . . . * N/C  CCNEXT-1  N/C    N/C
C
C          N/C => no change
C
30004 MORE=.FALSE.
      IF (.NOT.(CCNEXT.LE.NS)) GO TO 20009
      CCSAVE=CCNEXT
      GO TO 20013
20012 IF (MORE .OR. CCNEXT.GT.NS) GO TO 20014
20013 BYTE=CHGET3(STMT,CCNEXT)
      IF (.NOT.(BYTE.EQ.BLNKRZ)) GO TO 20015
      CCNEXT=CCNEXT+1
      GO TO 20016
20015 IF (.NOT.(F4CLC(STMT,CCNEXT,COMCHR,1,LCCHR))) GO TO 10001
      CCNEXT=NS+1
      CCSAVE=NS+1
      GO TO 20016
10001 MORE=.TRUE.
      CCMORE=CCNEXT
20016 CONTINUE
20017 GO TO 20012
20014 IF (.NOT.MORE) NS = MAX0(CCSAVE-1,1)
20009 CONTINUE
20010 GO TO NPR004, (20021,20031,20038)
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Find)
C
C          Tests for match between given string and the next N bytes
C          of the current statement.
C
C          Outputs:
C             IF (MORE .AND. FIND) THEN
C                SCANER = .TRUE.
C                CC .=. byte where search for match began in
C                       current statement
C                MORE, CCMORE, & NS AS PER PROC #4
C             ELSE
C                SCANER = .FALSE.
C                CC, MORE, CCMORE, & NS UNCHANGED
C             END IF
C
C          SCANER = MORE .AND. (CCMORE+N-1.LE.NS)
C    X              .AND. F4CLC(STRING,1,STMT,CCMORE,N)
C
30002 SCANER = MORE .AND. (CCMORE+N-1.LE.NS)
      IF (SCANER) SCANER = F4CLC(STRING,1,STMT,CCMORE,N)
      IF (.NOT.(SCANER)) GO TO 20018
      CC=CCMORE
      CCNEXT=CCMORE+N
      ASSIGN 20021 TO NPR004
      GO TO 30004
20021 CONTINUE
20018 GO TO 20007
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Locate)
C
C          Locates next occurrence of N-th byte of string in  the
C          current statement.  Parenthesis level is checked (must
C          be the same) and quoted strings are ignored.
C
C          Outputs:
C             IF (MORE .AND. LOCATE) THEN
C                SCANER = .TRUE.
C                CC .=. LOCATION OF OCCURRENCE
C                MORE, CCMORE, & NS AS PER PROC #4
C             ELSE
C                SCANER = .FALSE.
C                CC, MORE, CCMORE, & NS UNCHANGED
C             END IF
C
30003 IF (.NOT.(MORE)) GO TO 20022
      GIVEN = CHGET3(STRING,N)
      CCNEXT=CCMORE
      LEVL=0
      QUOTED=.FALSE.
      GO TO 20026
20025 IF (MATCH .OR. CCNEXT.GT.NS) GO TO 20027
20026 NXT = CHGET3(STMT,CCNEXT)
      MATCH=NXT.EQ.GIVEN .AND. LEVL.EQ.0 .AND.
     X.NOT.QUOTED
      IF (.NOT.(MATCH)) GO TO 20028
      CC=CCNEXT
      CCNEXT=CCNEXT+1
      ASSIGN 20031 TO NPR004
      GO TO 30004
20031 GO TO 20029
20028 IF (.NOT.(NXT.EQ.QUOTRZ)) GO TO 20032
      QUOTED=.NOT.QUOTED
      GO TO 20033
20032 IF (.NOT.(.NOT.QUOTED)) GO TO 20035
      IF (NXT.EQ.LEFTRZ)  LEVL=LEVL+1
      IF (NXT.EQ.RITERZ) LEVL=LEVL-1
20035 CONTINUE
20036 CONTINUE
20033 CONTINUE
20034 CCNEXT=CCNEXT+1
20029 GO TO 20025
20027 SCANER=MATCH
      GO TO 20023
20022 SCANER=.FALSE.
20023 GO TO 20008
C
C-----------------------------------------------------------------------
C---- PROCEDURE (Scan)
C
C          Looks for next non-blank character in current statement
C            STRING = dummy argument (not used at this entry),
C            N = index of first byte of statement to be tested.
C          Outputs:
C             CC .=. byte where scan began
C             MORE, CCMORE, & NS AS PER PROC #4
C             SCANER = MORE
C
30001 CC=N
      CCNEXT=N
      ASSIGN 20038 TO NPR004
      GO TO 30004
20038 SCANER=MORE
C
      GO TO 20006
C
      END
